# "help" command
#
# Copyright (C) 2013  Patrick McDermott
#
# This file is part of the ProteanOS Development Kit.
#
# The ProteanOS Development Kit is free software: you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The ProteanOS Development Kit is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with the ProteanOS Development Kit.  If not, see
# <http://www.gnu.org/licenses/>.

cmd_help_main()
{
	local cmd=

	if [ ${#} -eq 1 ]; then
		cmd="${1}"
		shift 1
		if is_cmd "${cmd}"; then
			print_cmd_usage "${cmd}"
			return 0
		fi
	fi

	printf "$(get_msg 'cmd_help_head')\n\n" "${0}"

	printf "$(get_msg 'cmd_help_opts_head')\n"
	print_opt_summaries
	printf '\n'

	printf "$(get_msg 'cmd_help_summary_head')\n"
	print_cmd_summaries

	return 0
}

cmd_help_register()
{
	register_cmd 'help'
}
__init cmd_help_register
